PROGRAM ICRINRE;

{*INFILTRACION EN CANALES DE RIEGO NO REVESTIDOS*}

{$R+,V-}
{

*Este programa da solucin a las ecuaciones de RICHARDS para dos
 direcciones de flujo.*

 ************************************************
 * Elabor : Ing. Nicols Romero Gmez          *
 * Universidad Nacional Autnoma de Mxico UNAM *
 * Facultad de Ingeniera FI                    *
 * Divisin de Estudios de Postgrado de la      *
 * Facultad de Ingeniera  DEPFI                *
 * Seccin de Hidrulica                        *
 ************************************************

   Versin Final Agosto 4 de 1995.

}
USES
   CRT, MENUS, PRINTER;
VAR

   ArchivoMenus        :  FILE;
   Mensaje             :  STRING;
   NDT, Tr, DT         :  LONGINT;
   Intervalo,
   Opcion,
   Icd, Opc,
   DT1, DT2, DT3, DT4,
   NDT1, NDT2,
   NDT3, NDT4,
   DDT1, DDT2,
   DDT3, DDT4          :  INTEGER;
   IniMem              :  POINTER;
   Hil, Col            :  SHORTINT;
   FP,
   CHi,CHs,CHr,Ks,
   Alfa,N,DX,DZ,
   FP1, FP2, FP3,
   FP4, M, Hi, Ki,
   CEi, DK, NU, Hym,
   KZ, KX, CEP, DKX,
   DKP,K,DKZ, Eta,
   Eta1, Lamda,
   Lamda1,Hmax,
   VOL, Suma           :  REAL;
   Hy                  :  BYTE;
   CondIni, CondPost   :  ARRAY[0..40,-30..70] OF REAL;

Procedure Error;
{ Procedimiento para enviar mensaje de error de datos en la funcin eleva }
BEGIN
   PresentaMenu(2, ArchivoMenus);
   Mensaje := 'Programa para el clculo de infiltracin por la ecuacin de Richards';
   MoveT(Mensaje[1], LENGTH(Mensaje), 2, 6, 80, 0, IMV);
   MoveA(26, LENGTH(Mensaje), 2, 6, 80, IMV);
   Mensaje := 'Tenga cuidado, ya que existe error de datos';
   MoveT(Mensaje[1], LENGTH(Mensaje), 12, 20, 80, 0, IMV);
   MoveA(26, LENGTH(Mensaje), 12, 20, 80, IMV);
   ReadLn;
{  Exit;}
END;
FUNCTION Eleva(Base,Expo:REAL):REAL;
{ Funcin para elevar una base a cualquier potencia }
BEGIN
   IF Base > 0 THEN
      BEGIN
         IF Expo > 0 THEN Eleva := EXP(Expo * LN(Base));
         IF Expo = 0 THEN Eleva := 1;
         IF Expo < 0 THEN Eleva := 1 / EXP(ABS(Expo) * LN(Base));
      END;

   IF Base = 0 THEN
      BEGIN
         IF Expo > 0 THEN Eleva := 0;
         IF Expo = 0 THEN Error;
         IF Expo < 0 THEN Error;
      END;

   IF Base < 0 THEN
      BEGIN
         IF TRUNC(Expo) = Expo THEN
            BEGIN
               IF Expo > 0 THEN
                  BEGIN
                     IF Expo/2 = TRUNC(Expo/2) THEN Eleva := EXP(Expo * LN(ABS(Base))){Expo entero y par}
                     ELSE Eleva:= -1*(EXP(Expo*LN(ABS(Base))));{Expo entero impar}
                  END;

               IF Expo = 0 THEN Eleva := 1;

               IF Expo < 0 THEN
                  BEGIN
                     IF TRUNC(Expo/2)=(Expo/2) THEN Eleva:=(EXP(Expo*LN(ABS(Base))))
                     ELSE Eleva:=-(EXP(Expo*LN(ABS(Base))));
                  END;
            END
         ELSE Error;
      END;
END;
PROCEDURE Lectura;
{ Procedimiento de lectura de datos }
BEGIN
   PresentaMenu(3, ArchivoMenus);
   CHi  := 0.1;
   CHs  := 0.45;
   CHr  := 0.05;
   Ks   := 0.000002777;
   Alfa := -0.3237;
   N    := 4.1738;
   DX   := 0.01;
   DZ   := 0.01;
   FP1  := 1.0;
   FP2  := 0.6;
   FP3  := 0.3;
   FP4  := 0.5;
   Hy   := 25;
   Mensaje := 'Programa para el clculo de infiltracin por la ecuacin de Richards';
   MoveT(Mensaje[1], LENGTH(Mensaje), 2, 6, 80, 0, IMV);
   MoveA(26, LENGTH(Mensaje), 2, 6, 80, IMV);
   Mensaje := 'F3 Para continuar';
   MoveT(Mensaje[1], LENGTH(Mensaje), 24, 8, 80, 0, IMV);
   MoveA(31, LENGTH(Mensaje), 24, 8, 80, IMV);
   Mensaje := 'ESC Para cancelar';
   MoveT(Mensaje[1], LENGTH(Mensaje), 24, 57, 80, 0, IMV);
   MoveA(31, LENGTH(Mensaje), 24, 57, 80, IMV);

   Mensaje := 'Indique los siguientes datos:';
   MoveT(Mensaje[1], LENGTH(Mensaje), 4, 24, 80, 0, IMV);
   MoveA(31, LENGTH(Mensaje), 4, 24, 80, IMV);

   ImprimeVp(@CHi,@CHs,@CHr,@Ks,@Alfa,@N,@DX,@DZ,
              @FP1,@FP2,@FP3,@FP4,@Hy,NIL,NIL,NIL,Icd);

    Leepantalla([#27,#125],1,3,ArchivoMenus,Opc);
    IF Opc = 27 THEN HALT;

    Asignavp(@CHi,@CHs,@CHr,@Ks,@Alfa,@N,@DX,@DZ,
              @FP1,@FP2,@FP3,@FP4,@Hy,NIL,NIL,NIL,Icd);

   PresentaMenu(5, ArchivoMenus);
   Mensaje := 'Programa para el clculo de infiltracin por la ecuacin de Richards';
   MoveT(Mensaje[1], LENGTH(Mensaje), 2, 6, 80, 0, IMV);
   MoveA(26, LENGTH(Mensaje), 2, 6, 80, IMV);
   Mensaje := 'F3 Para continuar';
   MoveT(Mensaje[1], LENGTH(Mensaje), 24, 8, 80, 0, IMV);
   MoveA(31, LENGTH(Mensaje), 24, 8, 80, IMV);
   Mensaje := 'ESC Para cancelar';
   MoveT(Mensaje[1], LENGTH(Mensaje), 24, 57, 80, 0, IMV);
   MoveA(31, LENGTH(Mensaje), 24, 57, 80, IMV);

   Mensaje := 'Indique los datos para cada diferencial de tiempo';
   MoveT(Mensaje[1], LENGTH(Mensaje), 4, 15, 80, 0, IMV);
   MoveA(31, LENGTH(Mensaje), 4, 15, 80, IMV);

   DT1  := 60;
   DDT1 := 11;
   DT2  := 115;
   DDT2 := 49;
   DT3  := 120;
   DDT3 := 108;
   DT4  := 135;
   DDT4 := 195;

   ImprimeVp(@DT1,@DDT1,@DT2,@DDT2,@DT3,@DDT3,@DT4,@DDT4,
              NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,Icd);

    Leepantalla([#27,#125],1,3,ArchivoMenus,Opc);
    IF Opc = 27 THEN HALT;

    Asignavp(@DT1,@DDT1,@DT2,@DDT2,@DT3,@DDT3,@DT4,@DDT4,
              NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,Icd);
END;

PROCEDURE ImprimeMonitor;
BEGIN
   FOR Col := 0 TO 40 DO
      BEGIN
         FOR Hil := -30 TO 70 DO
            BEGIN
               WRITE(Col:3,Hil:3,CondIni[Col,Hil]:7:3);
               IF (Hil MOD 6 = 0) THEN WRITELN;
            END;
         WRITELN;
      END;
END;

PROCEDURE ImprimeImpresora;
VAR
   Posicion  : BYTE;
BEGIN
   WRITELN(LST,CHAR(#15));
   WRITELN(LST);
   WRITELN(LST,'IMPRESION DE RESULTADOS DE LA MATRIZ':50);
   FOR Col := 0 TO 40 DO
      BEGIN
         Posicion := 0;
         FOR Hil := -30 TO 70 DO
            BEGIN
               WRITE(LST,Col:2,',',Hil:3,CondIni[COL,HIL]:6:2);
               INC(Posicion);
               IF (Posicion MOD 19 = 0) THEN WRITELN(LST);
            END;
         WRITELN(LST);
      END;
END;

PROCEDURE CalculoInicial;
VAR
   Valor : REAL;
{ Procedimiento para clculos iniciales }
BEGIN
   M   := 1-(2/N);
   NU  := (1/M)+2;
   Hi  := Alfa * (Eleva((Eleva(((CHs-CHr)/(CHi-CHr)),1/M)-1),1/N));
   Ki  := Ks * Eleva(((CHi-CHr)/(CHs-CHr)),(1/M+2));
   CEi := -(M * N * (CHs-CHr)) * Eleva((Hi/Alfa),N-1) / (Alfa * (Eleva((1+Eleva(Hi/Alfa,N)),M+1)));
   DK  := (((N*M*NU*(-Ks)) * (Eleva((1/Eleva((1+Eleva((Hi/Alfa),N)),M)),NU-1)) * Eleva((Hi/Alfa),N-1))) /
         (Eleva((1+Eleva(Hi/Alfa,N)),M+1)*Alfa);
   Hym := Hy / 100.0;

   (*Llenado de del surco con Hi inicial*)
   FOR Col := 0 TO 40 DO
      BEGIN
         Valor := 0;

         FOR Hil := -30 TO 70 DO
            BEGIN
               (* Llenado de la matriz de las columnas de 0 a 19 e hileras de -30 a -Hy-1, con ceros *)
               IF (((Col >= 0) AND (Col <= 19)) AND ((Hil >= -30) AND (Hil <= (-Hy-1)))) THEN CondIni[Col,Hil] := 0.0;

               (* Llenado de la matriz de las columnas de 0 a 19 e hileras de -Hy a -1, con datos ascend. iniciando con 0 *)
               IF (((Hil >= -Hy) AND (Hil <= -1)) AND ((Col >= 0) AND (Col <= 19))) THEN
                  BEGIN
                     CondIni[Col,Hil] := Valor;
                     Valor := Valor + 0.01;
                  END;
               (* Llenado de la matriz de las columnas de 20 a 40 e hileras de -30 a -1, con Hi *)
               IF (((Col >= 20) AND (Col <= 40)) AND ((Hil >= -30) AND (Hil <= -1))) THEN CondIni[Col,Hil] := Hi;

               (* Llenado de la matriz de las columnas de 0 a 40 e hileras de 0 a 70, con Hi *)
               IF (((Col >= 0) AND (Col <= 40)) AND ((Hil >= 0) AND (Hil <= 70))) THEN CondIni[Col,Hil] := Hi;
            END;
      END;
   FOR Col := 0 TO 40 DO
   FOR Hil := -30 TO 70 DO
   CondPost[Col,Hil] := CondIni[Col,Hil];
END;

PROCEDURE Intervalo1;
BEGIN
   IF ((Hil = 0) AND ((Col > 0) AND (Col < 20 ))) THEN
      CondIni[Col,Hil] := CondIni[Col,Hil] + (Hy / 100.0);

   IF (((Hil >= -Hy) AND (Hil <= 0)) AND (Col = 20)) THEN
      CondIni[Col,Hil] := CondIni[Col,Hil] + (Hy + Hil) / 100.0;

   IF (((Hil >= -Hy) AND (Hil < 0)) AND (Col = 19)) THEN
      CondIni[Col-1,Hil] := (Hy + Hil) / 100.0;

   IF ((Col > 0) AND (Col < 20)) AND (Hil = 0) THEN
      CondIni[Col,Hil-1] := (Hy-1)/100.0;
END;

PROCEDURE General;
BEGIN
   IF (((Hil >= -Hy) AND (Hil < 0)) AND (Col = 19)) THEN
      CondIni[Col-1,Hil] := (Hy + Hil) / 100.0;

   IF ((Col > 0) AND (Col < 20)) AND (Hil = 0) THEN
      CondIni[Col,Hil-1] := (Hy-1)/100.0;

   IF ((Hil = 0) AND ((Col > 0) AND (Col < 20))) THEN
      CondIni[Col,Hil] := CondIni[Col,Hil] + (Hy / 100.0);

   IF (((Hil >= -Hy) AND (Hil <= 0)) AND (Col = 20)) THEN
      CondIni[Col,Hil] := CondIni[Col,Hil] + (Hy + Hil) / 100.0;

   IF ((Col >= 20) AND (Col <= 40)) AND ((Hil >= Hy) AND (Hil <= 0)) THEN
      IF CondIni[Col,Hil] >= 0 THEN CondIni[Col,Hil] := (Hy - Hil) / 100.0;

   IF ((Col >= 0) AND (Col <= 40)) AND ((Hil >= 0) AND (Hil < 70)) THEN
      IF CondIni[Col,Hil] >= 0 THEN CondIni[Col,Hil] := Hy / 100.0;

   Hmax := Alfa * (Eleva((Eleva(((CHs-CHr)/((CHs*0.9)-CHr)),1/M)-1),1/N));

   IF ((Col >= 20) AND (Col <= 40)) AND ((Hil >= - 30) AND (Hil < -Hy)) THEN
      IF CondIni[Col,Hil] >= Hmax THEN CondIni[Col,Hil] := 0.0;

   IF ((Col >= 20) AND (Col <= 40)) AND ((Hil >= -Hy) AND (Hil < 0)) THEN
      IF CondIni[Col,Hil] >= Hmax THEN CondIni[Col,Hil] := Hy / 100.0;

   IF ((Col >= 0) AND (Col <= 40)) AND ((Hil >= 0) AND (Hil < 70)) THEN
      IF CondIni[Col,Hil] >= Hmax THEN CondIni[Col,Hil] := Hy / 100.0;
END;
PROCEDURE Continua1;
BEGIN
   IF (((Hil >= -30) AND (Hil <= -Hy-1)) AND (Col = 20)) THEN
      CondIni[Col-1,Hil] := CondIni[Col,Hil];

   IF ((Hil = -30) AND ((Col >= 20) AND (Col <= 40))) THEN
      CondIni[Col,Hil] := CondIni[Col,Hil+1];

   IF ((Col = 40) AND ((Hil >= -30) AND (Hil <= 70))) THEN
      CondIni[Col,Hil] := CondIni[Col-1, Hil];

   IF ((Hil = 70) AND ((Col >= 0) AND (Col <= 40))) THEN
      CondIni[Col,Hil] := 0.0;

   IF ((Col = 0) AND ((Hil >= 0) AND (Hil <= 70))) THEN
      CondIni[Col,Hil] := CondIni[Col+1,Hil];

   IF (((Col >= 19) AND (Col <= 40)) AND ((Hil >= -30) AND (Hil < -1))) THEN
      IF CondIni[Col,Hil] >= 0 THEN K := Ks
      ELSE
         BEGIN
            K  := Ks / (Eleva(( 1+ Eleva(CondIni[Col,Hil]/Alfa,N)),NU*M));
         END;

   IF (((Col >= 0) AND (Col <= 40)) AND (Hil >= -1) AND (Hil <= 70)) THEN
      IF CondIni[Col,Hil] >= 0 THEN K := Ks
      ELSE
         BEGIN
            K  := Ks / (Eleva(( 1+ Eleva(CondIni[Col,Hil]/Alfa,N)),NU*M));
         END;
END;

PROCEDURE CalculaKXYDKX;
BEGIN
   KX  := Ks;
   DKX := 0.0;

   IF ((COL = 20) AND ((HIL >= -Hy) AND (HIL < 0))) THEN
      IF CondIni[Col,Hil] >= 0 THEN
         BEGIN
            KX  := Ks;
            DKX := 0.0;
         END
      ELSE
         BEGIN
            KX  := SQRT((Ks / (Eleva(( 1+ Eleva(CondIni[Col+1,Hil]/Alfa,N)),NU*M)))*Ks);
            DKX := 0.0;
         END;

   IF ((COL = 20) AND ((HIL >= -30) AND (HIL < -Hy))) THEN
      IF CondIni[Col,Hil] >= 0 THEN
         BEGIN
            KX  := Ks;
            DKX := 0.0;
         END
      ELSE
         BEGIN
            KX  := SQRT((Ks / (Eleva(( 1+ Eleva(CondIni[Col+1,Hil]/Alfa,N)),NU*M)))*
                   (Ks / (Eleva(( 1+ Eleva(CondIni[Col+1,Hil]/Alfa,N)),NU*M))));

            DKX := SQRT(((((N*M*NU*(-Ks)) * (Eleva((1/Eleva((1+Eleva((CondIni[Col+1,Hil]/Alfa),N)),M)),NU-1)) *
                   Eleva((CondIni[Col+1,Hil]/Alfa),N-1))) / (Eleva((1+Eleva(CondIni[Col+1,Hil]/Alfa,N)),M+1)*
                   Alfa)) *
                   ((((N*M*NU*(-Ks)) * (Eleva((1/Eleva((1+Eleva((CondIni[Col+1,Hil]/Alfa),N)),M)),NU-1)) *
                   Eleva((CondIni[Col+1,Hil]/Alfa),N-1))) / (Eleva((1+Eleva(CondIni[Col+1,Hil]/Alfa,N)),M+1)*
                   Alfa)));
         END;

   IF (((Col > 0)  AND (Col < 40)) AND (Hil = 70)) THEN
      BEGIN
         KX := Ks;
         DKX := 0.0;
      END;

   IF (((Col > 20) AND (Col < 40)) AND ((Hil >= -30) AND (Hil < 0))) THEN
      BEGIN
         IF ((CondIni[Col,Hil] < 0) AND ((CondIni[Col-1,Hil] >= 0) AND (CondIni[Col+1,Hil] < 0))) THEN
            BEGIN
               KX  := SQRT(Ks*(Ks / (Eleva(( 1+ Eleva(CondIni[Col+1,Hil]/Alfa,N)),NU*M))));
               DKX := 0.0;
            END;

         IF ((CondIni[Col,Hil] < 0) AND ((CondIni[Col-1,Hil] < 0) AND (CondIni[Col+1,Hil] >= 0))) THEN
            BEGIN
               KX  := SQRT(Ks*(Ks / (Eleva(( 1+ Eleva(CondIni[Col-1,Hil]/Alfa,N)),NU*M))));
               DKX := 0.0;
            END;

         IF ((CondIni[Col,Hil] >= 0) AND ((CondIni[Col-1,Hil] >= 0) AND (CondIni[Col+1,Hil] >= 0))) THEN
            BEGIN
               KX  := Ks;
               DKX := 0.0;
            END;

         IF ((CondIni[Col,Hil] < 0) AND ((CondIni[Col-1,Hil] >= 0) AND (CondIni[Col+1,Hil] >= 0))) THEN
            BEGIN
               KX  := Ks;
               DKX := 0.0;
            END;

         IF ((CondIni[Col,Hil] < 0) AND ((CondIni[Col-1,Hil] < 0) AND (CondIni[Col+1,Hil] < 0))) THEN
            BEGIN
               KX := SQRT((Ks / (Eleva(( 1+ Eleva(CondIni[Col+1,Hil]/Alfa,N)),NU*M)))*
                     (Ks / (Eleva(( 1+ Eleva(CondIni[Col-1,Hil]/Alfa,N)),NU*M))));

               DKX := SQRT(((((N*M*NU*(-Ks)) * (Eleva((1/Eleva((1+Eleva((CondIni[Col+1,Hil]/Alfa),N)),M)),NU-1)) *
                      Eleva((CondIni[Col+1,Hil]/Alfa),N-1))) / (Eleva((1+Eleva(CondIni[Col+1,Hil]/Alfa,N)),M+1)*
                      Alfa)) *
                      ((((N*M*NU*(-Ks)) * (Eleva((1/Eleva((1+Eleva((CondIni[Col-1,Hil]/Alfa),N)),M)),NU-1)) *
                      Eleva((CondIni[Col-1,Hil]/Alfa),N-1))) / (Eleva((1+Eleva(CondIni[Col-1,Hil]/Alfa,N)),M+1)*
                      Alfa)));
            END;
      END;

   IF (((Col > 0) AND (Col < 40)) AND (Hil >= 0) AND (Hil < 70)) THEN
      BEGIN

         IF ((CondIni[Col,Hil] < 0) AND ((CondIni[Col-1,Hil] >= 0) AND (CondIni[Col+1,Hil] < 0))) THEN
            BEGIN
               KX  := SQRT(Ks*(Ks / (Eleva(( 1+ Eleva(CondIni[Col+1,Hil]/Alfa,N)),NU*M))));
               DKX := 0.0;
            END;

         IF ((CondIni[Col,Hil] < 0) AND ((CondIni[Col-1,Hil] < 0) AND (CondIni[Col+1,Hil] >= 0))) THEN
               BEGIN
                  KX  := SQRT(Ks*(Ks / (Eleva(( 1+ Eleva(CondIni[Col-1,Hil]/Alfa,N)),NU*M))));
                  DKX := 0.0;
               END;

         IF ((CondIni[Col,Hil] >= 0) AND ((CondIni[Col-1,Hil] >= 0) AND (CondIni[Col+1,Hil] >= 0))) THEN
            BEGIN
               KX  := Ks;
               DKX := 0.0;
            END;

         IF ((CondIni[Col,Hil] < 0) AND ((CondIni[Col-1,Hil] >= 0) AND (CondIni[Col+1,Hil] >= 0))) THEN
            BEGIN
               KX  := Ks;
               DKX := 0.0;
            END;

         IF ((CondIni[Col,Hil] < 0) AND ((CondIni[Col-1,Hil] < 0) AND (CondIni[Col+1,Hil] < 0))) THEN
            BEGIN
               KX := SQRT((Ks / (Eleva(( 1+ Eleva(CondIni[Col+1,Hil]/Alfa,N)),NU*M)))*
                     (Ks / (Eleva(( 1+ Eleva(CondIni[Col-1,Hil]/Alfa,N)),NU*M))));

               DKX := SQRT(((((N*M*NU*(-Ks)) * (Eleva((1/Eleva((1+Eleva((CondIni[Col+1,Hil]/Alfa),N)),M)),NU-1)) *
                      Eleva((CondIni[Col+1,Hil]/Alfa),N-1))) / (Eleva((1+Eleva(CondIni[Col+1,Hil]/Alfa,N)),M+1)*
                      Alfa)) *
                      ((((N*M*NU*(-Ks)) * (Eleva((1/Eleva((1+Eleva((CondIni[Col-1,Hil]/Alfa),N)),M)),NU-1)) *
                      Eleva((CondIni[Col-1,Hil]/Alfa),N-1))) / (Eleva((1+Eleva(CondIni[Col-1,Hil]/Alfa,N)),M+1)*
                      Alfa)));
            END;
      END;
END;

PROCEDURE CondicionPosterior;
BEGIN
   IF CondIni[Col,Hil] >= 0.0 THEN
      BEGIN
         Eta    := 0.0;
         Eta1   := 0.0;
         Lamda  := 0.0;
         Lamda1 := 0.0;
         CondPost[Col,Hil] := 0.0;
      END
   ELSE
      BEGIN
         Eta    := (FP*DT*KZ)  / CEP;
         Eta1   := (FP*DT*DKZ) / CEP;
         Lamda  := ((1-FP) * (DT * KX))  / CEP;
         Lamda1 := ((1-FP) * (DT * DKX)) / CEP;
         CondPost[Col,Hil] := ((Eta * (CondIni[Col,Hil-1] - (2*CondIni[Col,Hil]) + CondIni[Col,Hil+1])) /
                              (DZ*DZ)) +
                              Eta1    * (((CondIni[Col,Hil+1] - CondIni[Col,Hil])   / DZ)
                              * ((CondIni[Col,Hil+1] - CondIni[Col,Hil]) / DZ)) -
                              Eta1    * ((CondIni[Col,Hil+1] - CondIni[Col,Hil])   / DZ) +
                              ((Lamda * (CondIni[Col-1,Hil]   - (2*CondIni[Col,Hil]) + CondIni[Col+1,Hil])) / (DX*DX)) +
                              Lamda1  * (((CondIni[Col+1,Hil] - CondIni[Col,Hil])   / DX) *
                              ((CondIni[Col+1,Hil] - CondIni[Col,Hil])   / DX)) + CondIni[Col,Hil];
      END;
END;

PROCEDURE Continua2;
BEGIN
   IF (((Col >= 20) AND (Col < 40)) AND ((Hil > -30) AND (Hil < 0))) THEN CondicionPosterior;

   IF (((Col > 0) AND (Col < 40)) AND (Hil >= 0) AND (Hil < 70)) THEN CondicionPosterior;

   IF (((Hil >= -30) AND (Hil < -Hy)) AND (Col = 19)) THEN
      CondPost[Col,Hil] := CondPost[Col+1,Hil];

   IF ((Hil = -30) AND ((Col >= 20) AND (Col <= 40))) THEN
      CondPost[Col,Hil] := CondPost[Col,Hil+1];

   IF ((Col = 40) AND ((Hil >= -30) AND (Hil <= 70))) THEN
      CondPost[Col,Hil] := CondPost[Col-1, Hil];

   IF ((Hil = 70) AND ((Col >= 0) AND (Col <= 40))) THEN
      CondPost[Col,Hil] := 0.0;

   IF ((Col = 0) AND ((Hil >= 0) AND (Hil <= 70))) THEN
      CondPost[Col,Hil] := CondPost[Col+1,Hil];
END;

PROCEDURE CerosEn70;
BEGIN
   FOR Col := 0 TO 40 DO
   FOR Hil := -30 TO 70 DO
      BEGIN
         IF ((Hil = 70) AND ((Col >= 0) AND (Col <= 40))) THEN
         CondPost[Col,Hil] := 0.0;
         CondIni[Col,Hil] := CondPost[Col,Hil];
      END;
END;

PROCEDURE EnviaAImpresion;
BEGIN
         IF Intervalo = 1 THEN
            BEGIN
               IF Opcion = 1 THEN ImprimeMonitor;
               IF Opcion = 2 THEN ImprimeImpresora;
               WRITELN('DIFERENCIAL DE TIEMPO NO.   ',Intervalo,'   DT = ',DT:5);
               IF Opcion = 2 THEN WRITELN(LST,'DIFERENCIAL DE TIEMPO NO.   ',Intervalo,'   DT = ',DT:5);
            END;
         IF Intervalo = NDT1 THEN
            BEGIN
               IF Opcion = 1 THEN ImprimeMonitor;
               IF Opcion = 2 THEN ImprimeImpresora;
               IF Opcion = 2 THEN WRITELN(LST,'DIFERENCIAL DE TIEMPO NO.   ',Intervalo,'   DT = ',DT:5);
            END;
         IF Intervalo = (NDT1 + NDT2) THEN
            BEGIN
               IF Opcion = 1 THEN ImprimeMonitor;
               IF Opcion = 2 THEN ImprimeImpresora;
               IF Opcion = 2 THEN WRITELN(LST,'DIFERENCIAL DE TIEMPO NO.   ',Intervalo,'   DT = ',DT:5);
            END;
         IF Intervalo = (NDT1 + NDT2 + NDT3) THEN
            BEGIN
               IF Opcion = 1 THEN ImprimeMonitor;
               IF Opcion = 2 THEN ImprimeImpresora;
               IF Opcion = 2 THEN WRITELN(LST,'DIFERENCIAL DE TIEMPO NO.   ',Intervalo,'   DT = ',DT:5);
            END;
         IF Intervalo = NDT THEN
            BEGIN
               IF Opcion = 1 THEN ImprimeMonitor;
               IF Opcion = 2 THEN ImprimeImpresora;
               IF Opcion = 2 THEN WRITELN(LST,'DIFERENCIAL DE TIEMPO NO.   ',Intervalo,'   DT = ',DT:5);
            END;
      IF Opcion = 2 THEN WRITELN(LST,'NUMERO DE DIFERENCIAL DE TIEMPO EN PRUEBA DE INFILTRACION ',Intervalo);
      WRITELN('NUMERO DE DIFERENCIAL DE TIEMPO EN PRUEBA DE INFILTRACION ',Intervalo);
END;

PROCEDURE FormulaG;
{ Procedimiento para calcular la frmula general }
BEGIN
   NDT1 := ROUND((60) * (DDT1 / DT1));
   NDT2 := ROUND((60) * (DDT2 / DT2));
   NDT3 := ROUND((60) * (DDT3 / DT3));
   NDT4 := ROUND((60) * (DDT4 / DT4));
   NDT := NDT1 + NDT2 + NDT3 + NDT4;
   WRITELN(NDT1:5,NDT2:5,NDT3:5,NDT4:5,NDT:12);
   Intervalo := 0;
   WHILE Intervalo < NDT DO
      BEGIN
         Intervalo := Intervalo + 1;
         IF Intervalo <= NDT1 THEN DT := DT1;
         IF ((Intervalo > NDT1) AND (Intervalo <= (NDT1 + NDT2))) THEN DT := DT2;
         IF ((Intervalo > (NDT1 + NDT2)) AND (Intervalo <= (NDT1 + NDT2 + NDT3))) THEN DT := DT3;
         IF ((Intervalo > (NDT1 + NDT2 + NDT3)) AND (Intervalo <= NDT)) THEN DT := DT4;
         FOR Col := 0 TO 40 DO
         FOR Hil := -30 TO 70 DO
            BEGIN
               IF ((Col >= 0)  AND (Col <= 19)) AND ((Hil >= 0)   AND (Hil <= 70)) THEN FP := FP1;
               IF ((Col >= 20) AND (Col <= 40)) AND ((Hil >= 0)   AND (Hil <= 70)) THEN FP := FP2;
               IF ((Col >= 20) AND (Col <= 40)) AND ((Hil >= -Hy) AND (Hil <= -1)) THEN FP := FP3;
               IF ((Col >= 20) AND (Col <= 40)) AND ((Hil >= -30) AND (Hil <= (-Hy-1))) THEN FP := FP4;

               IF (((Col >= 0) AND (Col < 19)) AND ((Hil >= -30) AND (Hil <= (-Hy-1)))) THEN

               ELSE
               BEGIN
               IF Intervalo = 1 THEN Intervalo1
               ELSE General;
               Continua1;

               KZ  := Ks;
               DKZ := 0.0;
               VOL := 0.0;
               IF (((Col > 0)  AND (Col < 20)) AND (Hil = 0)) THEN
                  IF CondIni[Col,Hil] >= 0 THEN
                     BEGIN
                        KZ  := Ks;
                        DKZ := 0.0;
                        VOL := (CHs - CHi)  * (DX * DZ * 0.01);
                     END
                  ELSE
                     BEGIN
                        KZ  := SQRT((Ks / (Eleva(( 1+ Eleva(CondIni[Col,Hil+1]/Alfa,N)),NU*M)))*Ks);
                        DKZ := 0.0;
                        VOL := ((CHr + (CHs - CHr) / (Eleva(1+(Eleva(CondIni[Col,Hil] / Alfa,N)),M))) - CHi) *
                        (DX * DZ * 0.01);
                     END;

               IF (((Col >= 20) AND (Col < 40)) AND ((Hil > -30) AND (Hil <= 0))) THEN
                  BEGIN
                     IF ((CondIni[Col,Hil] < 0) AND  ((CondIni[Col,Hil-1] >= 0) AND (CondIni[Col,Hil+1] < 0))) THEN
                        BEGIN
                           KZ  := SQRT(Ks*(Ks / (Eleva(( 1+ Eleva(CondIni[Col,Hil+1]/Alfa,N)),NU*M))));
                           DKZ := 0.0;
                           VOL := ((CHr + (CHs - CHr) / (Eleva(1+(Eleva(CondIni[Col,Hil] / Alfa,N)),M))) - CHi) *
                           (DX * DZ * 0.01);

                        END;

                     IF ((CondIni[Col,Hil] < 0) AND  ((CondIni[Col,Hil-1] < 0) AND (CondIni[Col,Hil+1] >= 0))) THEN
                        BEGIN
                           KZ  := SQRT(Ks*(Ks / (Eleva(( 1+ Eleva(CondIni[Col,Hil-1]/Alfa,N)),NU*M))));
                           DKZ := 0.0;
                           VOL := ((CHr + (CHs - CHr) / (Eleva(1+(Eleva(CondIni[Col,Hil] / Alfa,N)),M))) - CHi) *
                           (DX * DZ * 0.01);
                        END;


                     IF ((CondIni[Col,Hil] >= 0) AND ((CondIni[Col,Hil-1] >= 0) AND (CondIni[Col,Hil+1] >= 0))) THEN
                        BEGIN
                           KZ  := Ks;
                           DKZ := 0.0;
                           VOL := (CHs - CHi)  * (DX * DZ * 0.01);
                        END;

                     IF ((CondIni[Col,Hil] < 0) AND ((CondIni[Col,Hil-1] >= 0) AND (CondIni[Col,Hil+1] >= 0))) THEN
                        BEGIN
                           KZ  := Ks;
                           DKZ := 0.0;
                           VOL := ((CHr + (CHs - CHr) / (Eleva(1+(Eleva(CondIni[Col,Hil] / Alfa,N)),M))) - CHi) *
                           (DX * DZ * 0.01);
                        END;

                     IF (CondIni[Col,Hil] < 0) AND ((CondIni[Col,Hil-1] < 0) AND (CondIni[Col,Hil+1] < 0)) THEN
                        BEGIN
                           KZ := SQRT((Ks / (Eleva(( 1+ Eleva(CondIni[Col,Hil+1]/Alfa,N)),NU*M)))*
                                 (Ks / (Eleva(( 1+ Eleva(CondIni[Col,Hil-1]/Alfa,N)),NU*M))));

                           DKZ := SQRT(((((N*M*NU*(-Ks)) * (Eleva((1/Eleva((1+Eleva((CondIni[Col,Hil+1]/Alfa),N)),M)),NU-1)) *
                                  Eleva((CondIni[Col,Hil+1]/Alfa),N-1))) / (Eleva((1+Eleva(CondIni[Col,Hil+1]/Alfa,N)),M+1)*
                                  Alfa)) *
                                  ((((N*M*NU*(-Ks)) * (Eleva((1/Eleva((1+Eleva((CondIni[Col,Hil-1]/Alfa),N)),M)),NU-1)) *
                                  Eleva((CondIni[Col,Hil-1]/Alfa),N-1))) / (Eleva((1+Eleva(CondIni[Col,Hil-1]/Alfa,N)),M+1)*
                                  Alfa)));
                                  VOL := ((CHr + (CHs - CHr) / (Eleva(1+(Eleva(CondIni[Col,Hil] / Alfa,N)),M))) - CHi) *
                                  (DX * DZ * 0.01);
                        END;
                  END;

               IF (((Col > 0) AND (Col < 40)) AND (Hil > 0) AND (Hil < 70)) THEN
                  BEGIN
                     IF ((CondIni[Col,Hil] < 0) AND  ((CondIni[Col,Hil-1] >= 0) AND (CondIni[Col,Hil+1] < 0))) THEN
                        BEGIN
                           KZ  := SQRT(Ks*(Ks / (Eleva(( 1+ Eleva(CondIni[Col,Hil+1]/Alfa,N)),NU*M))));
                           DKZ := 0.0;
                           VOL := ((CHr + (CHs - CHr) / (Eleva(1+(Eleva(CondIni[Col,Hil] / Alfa,N)),M))) - CHi) *
                           (DX * DZ * 0.01);
                        END;

                     IF ((CondIni[Col,Hil] < 0) AND ((CondIni[Col,Hil-1] < 0) AND (CondIni[Col,Hil+1] >= 0))) THEN
                        BEGIN
                           KZ  := SQRT(Ks*(Ks / (Eleva(( 1+ Eleva(CondIni[Col,Hil-1]/Alfa,N)),NU*M))));
                           DKZ := 0.0;
                           VOL := ((CHr + (CHs - CHr) / (Eleva(1+(Eleva(CondIni[Col,Hil] / Alfa,N)),M))) - CHi) *
                           (DX * DZ * 0.01);
                        END;
                     IF ((CondIni[Col,Hil] >= 0) AND ((CondIni[Col,Hil-1] >= 0) AND (CondIni[Col,Hil+1] >= 0))) THEN
                        BEGIN
                           KZ  := Ks;
                           DKZ := 0.0;
                           VOL := (CHs - CHi)  * (DX * DZ * 0.01);
                        END;

                     IF ((CondIni[Col,Hil] < 0) AND ((CondIni[Col,Hil-1] >= 0) AND (CondIni[Col,Hil+1] >= 0))) THEN
                        BEGIN
                           KZ  := Ks;
                           DKZ := 0.0;
                           VOL := ((CHr + (CHs - CHr) / (Eleva(1+(Eleva(CondIni[Col,Hil] / Alfa,N)),M))) - CHi) *
                           (DX * DZ * 0.01);
                        END;

                     IF ((CondIni[Col,Hil] < 0) AND ((CondIni[Col,Hil-1] < 0) AND (CondIni[Col,Hil+1] < 0))) THEN
                        BEGIN
                           KZ := SQRT((Ks / (Eleva(( 1+ Eleva(CondIni[Col,Hil+1]/Alfa,N)),NU*M)))*
                                 (Ks / (Eleva(( 1+ Eleva(CondIni[Col,Hil-1]/Alfa,N)),NU*M))));

                           DKZ := SQRT(((((N*M*NU*(-Ks)) * (Eleva((1/Eleva((1+Eleva((CondIni[Col,Hil+1]/Alfa),N)),M)),NU-1)) *
                                  Eleva((CondIni[Col,Hil+1]/Alfa),N-1))) / (Eleva((1+Eleva(CondIni[Col,Hil+1]/Alfa,N)),M+1)*
                                  Alfa)) *
                                  ((((N*M*NU*(-Ks)) * (Eleva((1/Eleva((1+Eleva((CondIni[Col,Hil-1]/Alfa),N)),M)),NU-1)) *
                                  Eleva((CondIni[Col,Hil-1]/Alfa),N-1))) / (Eleva((1+Eleva(CondIni[Col,Hil-1]/Alfa,N)),M+1)*
                                  Alfa)));
                           VOL := ((CHr + (CHs - CHr) / (Eleva(1+(Eleva(CondIni[Col,Hil] / Alfa,N)),M))) - CHi) *
                           (DX * DZ * 0.01);
                        END;
                  END;

               CalculaKXYDKX;

               CEP := 1.0;

               IF (((Col >= 20) AND (Col < 40)) AND ((Hil > -30) AND (Hil < 0))) THEN
                  IF CondIni[Col,Hil] >= 0.0 THEN
                     CEP := 1.0
                  ELSE
                     CEP := -(M * N * (CHs-CHr)) * Eleva((CondIni[Col,Hil]/Alfa),N-1) /
                             (Alfa * (Eleva((1+Eleva(CondIni[Col,Hil]/Alfa,N)),M+1)));

               IF (((Col > 0) AND (Col < 40)) AND (Hil >= 0) AND (Hil < 70)) THEN
                  IF CondIni[Col,Hil] >= 0.0 THEN
                     CEP := 1.0
                  ELSE
                     CEP := -(M * N * (CHs-CHr)) * Eleva((CondIni[Col,Hil]/Alfa),N-1) /
                             (Alfa * (Eleva((1+Eleva(CondIni[Col,Hil]/Alfa,N)),M+1)));

               Continua2;
               END;
            Suma := Suma + VOL;

            END;
         CerosEn70;
         EnviaAImpresion;
         WRITELN('EL VOLUMEN DE AGUA CONSUMIDO ES: ',Suma:25:15);
         WRITELN;
        IF Opcion = 2 THEN
           BEGIN
              WRITELN(LST,'EL VOLUMEN DE AGUA CONSUMIDO ES: ',Suma:25:15);
              WRITELN(LST);
           END;
         Suma := 0.0;
      END;
END;

PROCEDURE Imprime;
BEGIN
   PresentaMenu(4, ArchivoMenus);
   Mensaje := 'Programa para el clculo de infiltracin por la ecuacin de Richards';
   MoveT(Mensaje[1], LENGTH(Mensaje), 2, 6, 80, 0, IMV);
   MoveA(26, LENGTH(Mensaje), 2, 6, 80, IMV);
   Opcion := 0;
   Mensaje := 'Elija una de las siguientes opciones de impresin';
   MoveT(Mensaje[1], LENGTH(Mensaje), 6, 15, 80, 0, IMV);
   MoveA(30, LENGTH(Mensaje), 6, 15, 80, IMV);
   Opcion := NumOpcTex;
   CASE Opcion OF
      1 : ImprimeMonitor;
      2 : ImprimeImpresora;
   END;
END;

PROCEDURE DecideImpresion;
VAR
   Respuesta : STRING;
   Resp      : INTEGER;
BEGIN
   PresentaMenu(2, ArchivoMenus);
   Mensaje := 'Programa para el clculo de infiltracin por la ecuacin de Richards';
   MoveT(Mensaje[1], LENGTH(Mensaje), 2, 6, 80, 0, IMV);
   MoveA(26, LENGTH(Mensaje), 2, 6, 80, IMV);
   Mensaje := 'Desea impresin (Si/No) ?';
   MoveT(Mensaje[1], LENGTH(Mensaje), 12, 26, 80, 0, IMV);
   MoveA(26, LENGTH(Mensaje), 12, 26, 80, IMV);
   Respuesta := 'S';
   LeeStr(Respuesta, 12, 52, 1, 1, ['S','s','N','n'], [#13], [#27], Resp);
   IF (Respuesta = 'S') OR (Respuesta = 's') THEN Imprime;
END;
{ Programa principal }
BEGIN
   MARK(IniMem);
   AbreMenus(ArchivoMenus, 'ICRINRE.MEN');
   Lectura;
   CalculoInicial;
   DecideImpresion;
   FormulaG;
   RELEASE(IniMem);
   CLRSCR;
   WRITELN(LST);
   WRITELN(LST,'TERMINO SATISFACTORIAMENTE EL PROCESO DE INFILTRACION');
   WRITELN(LST);
END.
